// dont forget to add pico_multicore in the target_link_libraries
// target_link_libraries(MCP4821dualCoreDDSconsoleViaUARTv01 pico_stdlib pico_multicore)
// CMakeLists.txt
// https://learnembeddedsystems.co.uk/basic-multicore-pico-example

#include <stdio.h>
#include <math.h>
#include "pico/stdlib.h"
#include "pico/multicore.h"
//#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\pico_multicore\include\pico\multicore.h>


#include "pico/time.h"
#include "hardware/irq.h"
#include "hardware/structs/adc.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_pwm\include\hardware\pwm.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_adc\include\hardware\adc.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_gpio\include\hardware\gpio.h>
//#include "hardware/adc.h"

#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_sync\include\hardware\sync.h>

#include "hardware/resets.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_spi\include\hardware\spi.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_spi\spi.c>


#define PWM_PIN1 2
#define PWM_PIN2 3

#define GPIO4 4
int toggle ;

#define ADCfactor 50

#define tftActive 0

//#define LOfrequency (57.0e3+0.5*0) // pi pico rds gen
#define LOfrequency (57.0e3-0.7) // wdr5
#define LOoffset 0

//#define costasLoopGain 0
//#define costasLoopGain 1e-2

#define costasLoopGain 2e-2  // good wdr5
//#define costasLoopGain 5e-2
/*
#define earlyPosition 2
#define latePosition 8-2
#define samplePosition 6
#define EarlyLateGain (RDSperiod/50.0)
*/
/*
#define earlyPosition 1
#define latePosition  7
//#define samplePosition 6
#define samplePosition 3
#define EarlyLateGain (RDSperiod/50.0)
*/
#define earlyPosition 1
#define latePosition  7
//#define samplePosition 6
#define samplePosition 6
#define EarlyLateGain (RDSperiod/50.0)


//#define samplePosition 4

//#define samplePosition 3



//#define EarlyLateGain (RDSperiod/100.0)
//#define EarlyLateGain (RDSperiod/50.0) 
//#define EarlyLateGain (0) 

int showTimer ;
#define showGroups 0
#define showSyncMessages 0

int stopTrigger=0 ;

//-----------------------------------------------------------------------------------

#define tftOn 1

// Color definitions
#define ILI9341_BLACK       0x0000      /*   0,   0,   0 */
#define ILI9341_NAVY        0x000F      /*   0,   0, 128 */
#define ILI9341_DARKGREEN   0x03E0      /*   0, 128,   0 */
#define ILI9341_DARKCYAN    0x03EF      /*   0, 128, 128 */
#define ILI9341_MAROON      0x7800      /* 128,   0,   0 */
#define ILI9341_PURPLE      0x780F      /* 128,   0, 128 */
#define ILI9341_OLIVE       0x7BE0      /* 128, 128,   0 */
#define ILI9341_LIGHTGREY   0xC618      /* 192, 192, 192 */
#define ILI9341_DARKGREY    0x7BEF      /* 128, 128, 128 */
#define ILI9341_BLUE        0x001F      /*   0,   0, 255 */
#define ILI9341_GREEN       0x07E0      /*   0, 255,   0 */
#define ILI9341_CYAN        0x07FF      /*   0, 255, 255 */
#define ILI9341_RED         0xF800      /* 255,   0,   0 */
#define ILI9341_MAGENTA     0xF81F      /* 255,   0, 255 */
#define ILI9341_YELLOW      0xFFE0      /* 255, 255,   0 */
#define ILI9341_WHITE       0xFFFF      /* 255, 255, 255 */
#define ILI9341_ORANGE      0xFD20      /* 255, 165,   0 */
#define ILI9341_GREENYELLOW 0xAFE5      /* 173, 255,  47 */
#define ILI9341_PINK        0xF81F

int chrColor = ILI9341_WHITE ; 
int chrBackground = ILI9341_BLACK ; 
int xLast=0 ;
int yLast=0 ;


#include "tftLib1.c"

//----------------------------------------------------------------------

#define GTfifoSize 8000 
volatile int GTfifo[GTfifoSize] ;
volatile int GTfifoPutPtr ;
volatile int GTfifoGetPtr ;

void GTfifoInit(){
  GTfifoGetPtr=0 ;
  GTfifoPutPtr=0 ;
  }

void GTfifoPut(int v){
  //printf("GTput %08XH @%5d\n",v,GTfifoPutPtr) ;
  GTfifo[GTfifoPutPtr++]=v ;
  if(GTfifoPutPtr>=GTfifoSize){ GTfifoPutPtr=0 ; }
  }

int GTfifoGet(){
  while(GTfifoGetPtr==GTfifoPutPtr){}
  int v=GTfifo[GTfifoGetPtr++] ;
  //printf("GTget %08XH\n",v) ;
  if(GTfifoGetPtr>=GTfifoSize){ GTfifoGetPtr=0 ; }
  return v ;
  }

#include "core1.c"

//----------------------------------------------------------------------

char printBuffer[128] ;

void xprintln(char *cp){
  GTputRemark(cp) ; GTputRemark("\n") ;
  }

void xprint(char *cp){
  GTputRemark(cp) ;
  } 

void BufferedPrint(char *cp){
  GTputRemark(cp) ;
  }   

//-----------------------------------------------------------------------------------

void uart_putc1(char c){
  GTputRemarkChr(c) ;
  //printf("%c",c) ;
  }

void uart_puts1 (char *s){
  while (*s){   
    uart_putc1(*s);
    s++;
    }
  }

void uart_blank(){
  uart_putc1(' ') ; 
  }

void uart_crlf(){
  uart_putc1(13) ; 
  uart_putc1(10) ;
  }

void uart_cr(){
  uart_putc1(13) ; 
  uart_putc1(10) ;
  }

void decout(int k){
  // uart_putc1(32) ;
  if(k<0){ uart_putc1('-') ; k=-k ; }
  uart_putc1( ((k/1000) % 10)+48 ) ;
  uart_putc1( ((k/100) % 10)+48 ) ;
  uart_putc1( ((k/10) % 10)+48 ) ;
  uart_putc1( (k % 10)+48 ) ;
  uart_putc1(32) ;
  }

void chr_out(uint8_t v){
  uart_putc1(v) ; 
  }

void hex_out(uint8_t v){
  v &=0b00001111 ;
  if (v<=9) { chr_out('0'+v) ; } 
    else { chr_out(v+'A'-10) ; } ;
  }

void byte_out(uint8_t v){
  hex_out(v>>4) ; 
  hex_out(v) ; 
  }

void word_out(uint16_t v){
  byte_out(v>>8) ; 
  byte_out(v) ; 
  }

void uart_word(uint16_t v){
  byte_out(v>>8) ; 
  byte_out(v) ; 
  }

//------------------------------------------------------------------------------------------------------

void adc_init(void) {
  // ADC is in an unknown state. We should start by resetting it
  reset_block(RESETS_RESET_ADC_BITS);
  unreset_block_wait(RESETS_RESET_ADC_BITS);
  // Now turn it back on. Staging of clock etc is handled internally
  adc_hw->cs = ADC_CS_EN_BITS;
  // Internal staging completes in a few cycles, but poll to be sure
  while (!(adc_hw->cs & ADC_CS_READY_BITS)) {
    tight_loop_contents();
    }
  }



int sampleTime=0 ;
int Isum,Qsum ;
static volatile int Ival,Qval ;

#define IntFifoSize 32768
#define IntFifoMask (32768-1)

volatile int IntFifoInPtr ;
volatile int IntFifoOutPtr ;
volatile int16_t IntFifoI[IntFifoSize] ;
volatile int16_t IntFifoQ[IntFifoSize] ;

void IntFifoInit(){
  IntFifoInPtr=0 ;
  IntFifoOutPtr=0 ;
  }

int inputVal ;
int pwm=0 ;

short DDStable[4096] ;
int DDSphase ;
int DDSfrequencyBase ;
int DDSfrequencyVCO ;
int DDSfrequency ;
int rdsVCO=0 ;

volatile int FrontendFilterII ;
volatile int FrontendFilterQQ ;
int Isum=0 ;
int Qsum=0 ;

volatile float costas1 ;
volatile int rxValue ;
volatile int rxValue2 ;

int downSample=0 ;

void on_pwm_wrap() {
  gpio_put(GPIO4, 1);
  // Clear the interrupt flag that brought us here
  int16_t adcv=(uint16_t) adc_hw->result;
  //int16_t adcv=adc_read2() ;
  hw_set_bits(&adc_hw->cs, ADC_CS_START_ONCE_BITS);
  pwm_clear_irq(pwm_gpio_to_slice_num(PWM_PIN1));
 
  rxValue2=ADCfactor*(adcv-2048) ;

  DDSphase=DDSphase+DDSfrequency+rdsVCO ;
  // DDSphase=DDSphase+DDSfrequency ;
  int loII=DDStable[ (DDSphase >> 20 ) & 0xFFF ] ;
  int loQQ=DDStable[ ((DDSphase >> 20 )+0x400) & 0xFFF ] ;

  Isum += loII*rxValue2 ;
  Qsum +=loQQ*rxValue2 ;
  sampleTime++ ;
  if(sampleTime>=25){ 
    FrontendFilterII=Isum/15000 ;
    FrontendFilterQQ=Qsum/15000 ;
    Isum=0 ;
    Qsum=0 ;
    sampleTime=0 ;
    IntFifoI[IntFifoInPtr]=FrontendFilterII ;
    IntFifoQ[IntFifoInPtr]=FrontendFilterQQ ;
    IntFifoInPtr=(IntFifoInPtr+1) & IntFifoMask ;
    }
  gpio_put(GPIO4, 0);
  }

//----------------------------------------------------------------------------------------

uint16_t cp_tab[1024] ;
int      ci_tab[1024]  ;

void setupTables(){
  int s ;
  for ( s=0 ; s<1024 ; s++){ 
    cp_tab[s]=0 ;
    ci_tab[s]=100 ; 
    }
  // one doublet error table 

cp_tab[0x0001]=0x0000; ci_tab[0x0001]=1 ;
cp_tab[0x0003]=0x0000; ci_tab[0x0003]=1 ;
cp_tab[0x0006]=0x0000; ci_tab[0x0006]=1 ;
cp_tab[0x000C]=0x0000; ci_tab[0x000C]=1 ;
cp_tab[0x0018]=0x0000; ci_tab[0x0018]=1 ;
cp_tab[0x0030]=0x0000; ci_tab[0x0030]=1 ;
cp_tab[0x0060]=0x0000; ci_tab[0x0060]=1 ;
cp_tab[0x00C0]=0x0000; ci_tab[0x00C0]=1 ;
cp_tab[0x0180]=0x0000; ci_tab[0x0180]=1 ;
cp_tab[0x0300]=0x0000; ci_tab[0x0300]=1 ;
cp_tab[0x03B9]=0x0001; ci_tab[0x03B9]=1 ;
cp_tab[0x02CB]=0x0003; ci_tab[0x02CB]=1 ;
cp_tab[0x002F]=0x0006; ci_tab[0x002F]=1 ;
cp_tab[0x005E]=0x000C; ci_tab[0x005E]=1 ;
cp_tab[0x00BC]=0x0018; ci_tab[0x00BC]=1 ;
cp_tab[0x0178]=0x0030; ci_tab[0x0178]=1 ;
cp_tab[0x02F0]=0x0060; ci_tab[0x02F0]=1 ;
cp_tab[0x0059]=0x00C0; ci_tab[0x0059]=1 ;
cp_tab[0x00B2]=0x0180; ci_tab[0x00B2]=1 ;
cp_tab[0x0164]=0x0300; ci_tab[0x0164]=1 ;
cp_tab[0x02C8]=0x0600; ci_tab[0x02C8]=1 ;
cp_tab[0x0029]=0x0C00; ci_tab[0x0029]=1 ;
cp_tab[0x0052]=0x1800; ci_tab[0x0052]=1 ;
cp_tab[0x00A4]=0x3000; ci_tab[0x00A4]=1 ;
cp_tab[0x0148]=0x6000; ci_tab[0x0148]=1 ;
cp_tab[0x0290]=0xC000; ci_tab[0x0290]=1 ;
cp_tab[0x0077]=0x8000; ci_tab[0x0077]=1 ;

  s=0 ; cp_tab[s]=0 ; ci_tab[s]=0 ;  // the no error word }

  }

uint16_t errcor(uint16_t xdata, uint16_t xcheck, uint16_t ofs , int* nErrors, int showFlag) {
  uint16_t cp ; 
  int errcnt ;
  uint16_t xCorrected=xdata ;
  xcheck=xcheck ^ ofs ;
  cp=cp_tab[xcheck] ;
  errcnt=ci_tab[xcheck]  ;
  *nErrors=0 ;
  if ( errcnt<=1 ){
    xCorrected=xCorrected ^ cp ;
    if ( errcnt!=0 ) { 
      if(showFlag==1) { sprintf(printBuffer,"  [[ %4X->%4X    cp=%4X ]]  ",xdata,xCorrected,cp) ; xprintln(printBuffer) ;  }
      *nErrors=1 ; 
      }
    }
   else { 
     //uartPutc('#') ;
     *nErrors=2 ; 
     }
 // uartPutc('0'+*nErrors) ;uartBlank() ; 
  return  xCorrected ;
  }


//---------------------------------------------------------------------
// syncronisation and group/block recovery layer 


uint8_t local_time ;
uint8_t synced_time,sync_point ;
uint16_t check,data,r_syndrom ;

volatile uint16_t blk_a_data, blk_a_check ;
volatile uint16_t blk_b_data, blk_b_check ;
volatile uint16_t blk_c_data, blk_c_check ;
volatile uint16_t blk_d_data, blk_d_check ;

uint16_t tmp_a_data, tmp_a_check ;
uint16_t tmp_b_data, tmp_b_check ;
uint16_t tmp_c_data, tmp_c_check ;
uint16_t tmp_d_data, tmp_d_check ;

volatile uint8_t group_ready ;
int8_t sync_message,sync_fifo0,sync_fifo1,sync_fifo2 ;
uint8_t cy,cy26 ;
//---------------------------------------------------------------------

#define  OFSA  0x0FC 
#define  OFSB  0x198 
#define  OFSC  0x168 
#define  OFSCS 0x350
#define  OFSD  0x1B4 
 
//---------------------------------------------------------------------


uint8_t RDSserviceName[8] ;
uint8_t RDSradioTextA[64] ;
uint8_t RDSradioTextB[64] ;
uint16_t RDSpi ;
int RDStp=0 ;
int RDSta=0 ;
int RDSms=0 ;


void clearRDSdata(){
  for(uint8_t k=0 ; k<8 ; k++){
    RDSserviceName[k]='.' ;
    }
  for(uint8_t k=0 ; k<64 ; k++){
    RDSradioTextA[k]='.' ;
    RDSradioTextB[k]='.' ;
    }
  RDSpi=0 ;
  }

char txt[100] ;


void displayRDSdata(){
  uart_crlf() ;
  xprint("PI=") ;
  uart_word(RDSpi) ;
  xprint(" ServiceName=[") ;
  for(uint8_t k=0 ; k<8 ; k++){
    uart_putc1(RDSserviceName[k]);
    }
  xprint("]\n\r") ;
  
  xprint("TextA=[") ;
  for(uint8_t k=0 ; k<64 ; k++){
    uart_putc1(RDSradioTextA[k]) ;
    }
  xprint("]\n\r") ;
  xprint("TextB=[") ;
  for(uint8_t k=0 ; k<64 ; k++){
    uart_putc1(RDSradioTextB[k]) ;
    }
  xprint("]\n\r") ;
 
  }


//---------------------------------------------------------------------
int makeChar(int x){
  if(x==0x0D){ return '|' ; }
  if(x<' '){ sprintf(printBuffer,"x=%2XH",x) ; xprint(printBuffer) ; return '?' ; }
  if(x>'z'){ sprintf(printBuffer,"x=%2XH",x) ; xprint(printBuffer) ; return '?' ; }
  return x ;
  }

void group4(uint16_t blk_b_data,uint16_t blk_c_data,uint16_t blk_d_data){
	
	sprintf(printBuffer,"\n%4X %4X %4X %4X ",blk_a_data,blk_b_data,blk_c_data,blk_d_data) ;
  GTputRemark(printBuffer) ;
	

	int16_t minutes=(blk_d_data>>6) &0b111111 ;
	int16_t hours=((blk_d_data>>12) &0b1111) | ((blk_c_data & 1)<<4) ;
	int32_t localOffset=blk_d_data & 0b11111 ;
	if( blk_d_data & 0b100000) { localOffset=-localOffset ; }
	// do offset correction
	minutes=minutes+30*localOffset ;
	int minCy=0 ;
	while (minutes>59)  { minutes=minutes-60 ; minCy=minCy+1 ; }
	while (minutes<0  ) { minutes=minutes+60 ; minCy=minCy-1 ; }
	hours=hours+minCy ;
	int hourCy=0 ;
	while (hours>=24 )  { hours=hours-1 ; hourCy=hourCy+1 ; }
	while (hours<0   )  { hours=hours+1 ; hourCy=hourCy-1 ; }

	sprintf(printBuffer," Time: %2d:%2d ",hours,minutes) ;
  GTputRemark(printBuffer) ;

	// do mjd correction }
	uint32_t mjd=((blk_c_data>>1) &0b111111111111111 ) |( ((uint32_t)(blk_b_data&0b11 ))<<15  ) ;
	uint32_t Ys=((mjd*100UL)-1507820UL)/36525 ;
	uint32_t help1=(Ys*1461UL)/4 ;
	uint32_t Ms=(mjd*10000UL-149561000UL-help1*10000UL)/306001UL ;
	// uartPutsPgm(PSTR(" Ms=")) ; uartDecOut32(Ms,-1) ;
	uint32_t help2 =(Ms*306001UL)/10000 ;
	uint32_t d1=mjd-14956-help1-help2 ;
	uint32_t k=0 ;
	if ((Ms==14) | (Ms==15)){  k=1 ; }
	uint32_t y=Ys+k ;
	uint32_t m=Ms-1-k*12 ;
	
   sprintf(printBuffer," %2d.%2d.%4d\n",d1,m,y+1900) ;
  GTputRemark(printBuffer) ;

  //  if(tftActive){
      sprintf(printBuffer,"Time: %2d:%2d  %2d.%2d.%4d",hours,minutes,d1,m,y+1900) ;
  
      GTputCrlf() ;
      GTputPrint(printBuffer) ;
      GTputCrlf() ;
  //    }
    
   // stopTrigger=1 ;
}



void RDSgroupDECODE(){
  group_ready=0 ;
 // if(tftActive){
    sprintf(printBuffer,"%04X %04X %04X %04X",blk_a_data,blk_b_data,blk_c_data,blk_d_data) ;
    GTputCrlf() ;
    GTputPrint(printBuffer) ;
 //  }

  if(stopTrigger>0){ stopTrigger++ ; }
  if(stopTrigger==5){ abort() ; }

  if(blk_a_data != RDSpi ){
    RDSpi=blk_a_data ;
    uart_crlf() ;
    xprint("new PI=") ;
    uart_word(RDSpi) ;
    uart_crlf() ;
    }
  if ( (blk_b_data & 0xf800)==0x4000 ) {
    group4(blk_b_data,blk_c_data,blk_d_data) ;
    return ;
    }
  if ( (blk_b_data & 0xf800)==0x0000 ) { 
    uint8_t sn0=(blk_d_data >>8) & 0xff ;
    uint8_t sn1=(blk_d_data    ) & 0xff ;
    uint8_t snADR=(blk_b_data & 0x0003 ) << 1 ;
    RDSserviceName[snADR+0]=sn0 ;
    RDSserviceName[snADR+1]=sn1 ;
 //   if(tftActive){
      GTputCrlf() ;
      GTputPutc(RDSserviceName[0]) ; 
      GTputPutc(RDSserviceName[1]) ; 
      GTputPutc(RDSserviceName[2]) ; 
      GTputPutc(RDSserviceName[3]) ; 
      GTputPutc(RDSserviceName[4]) ; 
      GTputPutc(RDSserviceName[5]) ; 
      GTputPutc(RDSserviceName[6]) ; 
      GTputPutc(RDSserviceName[7]) ; 
   //   }

    return ;
    } // group 0
  if ( (blk_b_data & 0xf800)==0x2000 ) { 
    uint8_t rt0=makeChar((blk_c_data >>8) & 0xff) ;
    uint8_t rt1=makeChar((blk_c_data    ) & 0xff) ;
    uint8_t rt2=makeChar((blk_d_data >>8) & 0xff) ;
    uint8_t rt3=makeChar((blk_d_data    ) & 0xff) ;
    uint8_t rtADR=(blk_b_data & 0x000f ) << 2 ;
    if ( (blk_b_data & 0x10)==0x10 ) { 
      RDSradioTextB[rtADR+0]=rt0 ; 
      RDSradioTextB[rtADR+1]=rt1; 
      RDSradioTextB[rtADR+2]=rt2 ; 
      RDSradioTextB[rtADR+3]=rt3 ;        
      }
     else {
      RDSradioTextA[rtADR+0]=rt0 ; 
      RDSradioTextA[rtADR+1]=rt1; 
      RDSradioTextA[rtADR+2]=rt2 ; 
      RDSradioTextA[rtADR+3]=rt3 ;      
      }
    return ;
    } // group 2a
  }


//---------------------------------------------------------------------

int count1=0 ;
long long oldTimeUs=0 ;
long long newTimeUs=0 ;


void  doRDSbit(uint8_t cy0) {
  const uint16_t  x26=0xEE ;
  const uint16_t gpol=0x1B9 ;
  const uint16_t bit9=0x200 ;
  local_time++ ;
  if ( local_time >= 104 ) { local_time=0 ; }
  synced_time++ ;
  if ( local_time==sync_point ) { synced_time=0 ; }
  check= ( check << 1 ) + cy0 ;
  if ((check & 0x400)==0 )  { cy=0 ; } else { cy=1 ; }
  if ( (data & 0x8000)==0x8000 ) { cy26=1 ; } else { cy26=0 ; }
  data= (data << 1 ) + cy ;
  if ((r_syndrom & bit9) != 0) { r_syndrom=(r_syndrom << 1 ) ^ gpol ; }
                              else { r_syndrom=r_syndrom << 1 ; }
  r_syndrom=r_syndrom ^ cy0 ;
  if ( cy26==1 ) { r_syndrom=r_syndrom ^ x26 ; }
  r_syndrom=r_syndrom & 0x3FF ;

// save blocks that are ready at the correct time }
  if ( synced_time ==26 ) { tmp_a_data=data ; tmp_a_check=r_syndrom ; }
  if ( synced_time ==52 ) { tmp_b_data=data ; tmp_b_check=r_syndrom ; }
  if ( synced_time ==78 ) { tmp_c_data=data ; tmp_c_check=r_syndrom ; }
  if ( synced_time ==0 )  { tmp_d_data=data ; tmp_d_check=r_syndrom ; 
    blk_a_data=tmp_a_data ; blk_a_check=tmp_a_check ;
    blk_b_data=tmp_b_data ; blk_b_check=tmp_b_check ;
    blk_c_data=tmp_c_data ; blk_c_check=tmp_c_check ;
    blk_d_data=tmp_d_data ; blk_d_check=tmp_d_check ;
    
    int errorsA ;
    int errorsB ;
    int errorsC ;
    int errorsD ;
       
    int heavyError=0 ;
    int showit=0 ;
    blk_a_data=errcor(blk_a_data,blk_a_check,OFSA,&errorsA,showit) ; if(errorsA>1){ heavyError=1 ; }
    blk_b_data=errcor(blk_b_data,blk_b_check,OFSB,&errorsB,showit) ; if(errorsB>1){ heavyError=1 ; }
    if (( blk_b_data & 0x0800) != 0){ 
      blk_c_data=errcor(blk_c_data,blk_c_check,OFSCS,&errorsC,showit) ; if(errorsC>1){ heavyError=1 ; } }
     else {
      blk_c_data=errcor(blk_c_data,blk_c_check,OFSC,&errorsC,showit) ; if(errorsC>1){ heavyError=1 ; } }
    blk_d_data=errcor(blk_d_data,blk_d_check,OFSD,&errorsD,showit) ; if(errorsD>1){ heavyError=1 ; }
    char errorsAA=' ' ; if(errorsA==1){ errorsAA='*' ; }
    char errorsBB=' ' ; if(errorsB==1){ errorsBB='*' ; }
    char errorsCC=' ' ; if(errorsC==1){ errorsCC='*' ; }
    char errorsDD=' ' ; if(errorsD==1){ errorsDD='*' ; }
    
    if( heavyError==0){
      group_ready=1 ;
      uart_putc1('+') ; 
/*
      newTimeUs=time_us_64() ;
      int dt=newTimeUs-oldTimeUs ;
      oldTimeUs=newTimeUs ;
      sprintf(printBuffer," T=%d ",dt) ;
      GTputRemark(printBuffer) ;
*/

      if(showGroups){
        sprintf(printBuffer," %04X ",blk_a_data) ; xprint(printBuffer) ;
        sprintf(printBuffer," %04X ",blk_b_data) ; xprint(printBuffer) ;
        sprintf(printBuffer," %04X ",blk_c_data) ; xprint(printBuffer) ;
        sprintf(printBuffer," %04X ",blk_d_data) ; xprintln(printBuffer) ;
        }
      RDSgroupDECODE() ;
      } else { 
      uart_putc1('?') ;
      count1++ ;
      if(count1>30){ xprintln("//") ; count1=0 ;}
      }
    showTimer++ ; if(showTimer>100){ showTimer=0 ; displayRDSdata() ; }
    }
// test wether sync messages arrive 
  sync_message=0x0F ;
  if ( r_syndrom == OFSA ) { sync_message=26 ;  }
  if ( r_syndrom == OFSB ) { sync_message=52 ;  }
  if ( r_syndrom == OFSC ) { sync_message=78 ;  }
  if ( r_syndrom == OFSCS) { sync_message=78 ;  }
  if ( r_syndrom == OFSD ) { sync_message=0  ;  }
  if ( sync_message!=0x0F ) {
    sync_message=local_time-sync_message ;
    if (sync_message<0 ) { sync_message=sync_message+104 ; }
    if(showSyncMessages){
      sprintf(printBuffer," #%3i ",sync_message) ;
      xprint(printBuffer) ;
      }
    sync_fifo0=sync_fifo1 ; 
    sync_fifo1=sync_fifo2 ; 
    sync_fifo2=sync_message ;
    if ( (sync_fifo0==sync_fifo1) && (sync_fifo1==sync_fifo2) ) { 
      sync_point=sync_fifo0 ; 
      }
    }

 
  }


//---------------------------------------------------------------------


void  restartRsyndrom(){ 
  r_syndrom=0 ;
  data=0 ;
  check=0 ;
  local_time=0 ;
  sync_point=0 ;
  group_ready=0 ;
  clearRDSdata() ;
  showTimer=0 ;
  setupTables() ;
  }
//---------------------------------------------------------------------

int sLast=0 ;
#define eyeBufSize 200
int eyeBufX1[eyeBufSize] ;
int eyeBufX2[eyeBufSize] ;
int eyeBufY1[eyeBufSize] ;
int eyeBufY2[eyeBufSize] ;
int eyeBufPtr=0 ;

void eyeInit(){
  sLast=0 ;
  eyeBufPtr=0 ;
  for(int k=0 ; k<eyeBufSize ; k++){
    eyeBufX1[k]=0 ;
    eyeBufX2[k]=0 ;
    eyeBufY1[k]=0 ;
    eyeBufY2[k]=0 ;
    }
  tftLine(0,220,100,220,ILI9341_WHITE) ;  
  }

int RDStimeAsInt ;
float lastRDStime ;
float RDStime ;
#define sampleTime2 (1.0/10000.0)
#define RDSperiod (1.0/1187.5)

//---------------------------------------------------------------------------------------

void LineEye(int x1, int y1, int x2, int y2 , int color){
  if(x1<0) { return ; }
  if(x1>150) { return ; }
  if(x2<0) { return ; }
  if(x2>150) { return ; }
  
  if(y1<100){ return ; }
  if(y1>315) { return ; }
  if(y2<100){ return ; }
  if(y2>315) { return ; }
  GTputLine(x1,y1,x2,y2,color) ;

}

void doEye(int s){
  if(RDStimeAsInt<1){ return ; }
  if(s>50) { s=50 ; }
  if(s<-50) { s=-50 ; }
  int color=0 ;
  int x1=40+12*(RDStimeAsInt-1) ;
  int x2=40+12*RDStimeAsInt ;
  int y1=220+2*sLast ;
  int y2=220+2*s ;
  sLast=s ; 
  if (RDStimeAsInt==samplePosition) { color=ILI9341_RED ; } else { color=ILI9341_WHITE ;  }
  //color=ILI9341_WHITE ; 
  LineEye(eyeBufX1[eyeBufPtr], eyeBufY1[eyeBufPtr], eyeBufX2[eyeBufPtr],eyeBufY2[eyeBufPtr],ILI9341_BLACK) ;
  eyeBufX1[eyeBufPtr]=x1 ;
  eyeBufX2[eyeBufPtr]=x2 ;
  eyeBufY1[eyeBufPtr]=y1 ;
  eyeBufY2[eyeBufPtr]=y2 ;
  eyeBufPtr++ ;
  if(eyeBufPtr>=eyeBufSize){ eyeBufPtr=0 ; }
  LineEye(x1, y1, x2,y2,color) ;
  }


//---------------------------------------------------------------------------------------

#define eye2N 10
#define eye2M 100
int Mcnt=0 ;
int eye2Old[eye2N] ;
int eye2New[eye2N] ;

void eye2dsp(){
  for(int k=0 ; k<eye2N ; k++){ eye2New[k] = 160+((2*eye2New[k])/eye2M) ; }
  for(int k=1 ; k<eye2N ; k++){ GTputLine(40+12*(k-1),eye2Old[k-1],40+12*k,eye2Old[k],ILI9341_BLACK) ; }
  GTputLine(40,160,40+12*eye2N,160,ILI9341_RED) ; 
  for(int k=1 ; k<eye2N ; k++){ GTputLine(40+12*(k-1),eye2New[k-1],40+12*k,eye2New[k],ILI9341_YELLOW) ; }
  for(int k=0 ; k<eye2N ; k++){ eye2Old[k]=eye2New[k] ; eye2New[k]=0 ;  }
  }

void doEye2(int v){
  if(v<0){ v=-v ; }
  if (RDStimeAsInt==0) {
    Mcnt++ ;
    if(Mcnt==eye2M){ Mcnt=0 ; eye2dsp() ;  }
    }
  if(RDStimeAsInt<eye2N){ eye2New[RDStimeAsInt]+=v ; }
  }

//---------------------------------------------------------------------------------------

int scopeCntr=0 ;
#define scopeSize 120 
#define scopeMax 40000

int scopeNewYi[scopeSize] ;
int scopeOldYi[scopeSize] ;

void scopeDisplay(){
  for(int k=1 ; k<scopeSize ; k++) {
    GTputLine(k-1,scopeOldYi[k-1],k,scopeOldYi[k],ILI9341_BLACK) ;
    GTputLine(k-1,scopeNewYi[k-1],k,scopeNewYi[k],ILI9341_WHITE) ;
    }
  for(int k=0 ; k<scopeSize ; k++) {  
    scopeOldYi[k]=scopeNewYi[k] ;
    }  
  }

void scope(int y){
scopeCntr++ ;
if(scopeCntr<scopeSize){
  scopeNewYi[scopeCntr]=80+y/200 ;
  }
 else if(scopeCntr==scopeSize){
   scopeDisplay() ;  
  }
 else if(scopeCntr==scopeMax){
  scopeCntr=0 ;  
  }
}

//---------------------------------------------------------------------------------------


float ClkPLLcorrection=0 ;

float ClkPLLearly ;
float ClkPLLlate ;
int ClkPLLcount ;

int xRDSsample=0 ;
int lastSample ;

int ampl1 ;
int ampl2 ;
int amplCnt=0 ;
#define amplM 10000 

int eyeDrawOn=0 ;
int dd=0 ;

void BitClkPLL(float x){
  float a=fabs(x) ;
 
  if(RDStimeAsInt==0){
    eyeDrawOn=0 ;
    dd++ ;
    if(dd>100){ eyeDrawOn=1 ; dd=0 ; }
    }
  if(eyeDrawOn){ 
    doEye(x/150) ; 
    }


  doEye2(x/150) ;
/*
  if(RDStimeAsInt==samplePosition) { ampl1+=a ; }
  if(RDStimeAsInt==6) { ampl2+=a ; }
  amplCnt++ ;
  if(amplCnt>=amplM){
    ampl1 /= amplM ;
    ampl2 /= amplM ;
    sprintf(printBuffer," A1=%d A2=%d ",ampl1,ampl2) ;
    GTputRemark(printBuffer) ;
    amplCnt=0 ;
    ampl1=0 ;
    ampl2=0 ;
    }
*/
  if(RDStimeAsInt==earlyPosition){  ClkPLLearly += a ; }
  if(RDStimeAsInt==latePosition){  ClkPLLlate += a ; }
  if(RDStimeAsInt==samplePosition) {
      xRDSsample=(x>0) ;
      doRDSbit( xRDSsample!=lastSample) ;
      lastSample=xRDSsample ;
      }
  ClkPLLcount++ ;
  if(ClkPLLcount==100){
    if(  ClkPLLearly> ClkPLLlate){ 
      ClkPLLcorrection=EarlyLateGain ; 
      }
     else { 
      ClkPLLcorrection=-EarlyLateGain ; 
       }
    ClkPLLearly=0 ;
    ClkPLLlate=0 ;
    ClkPLLcount=0 ;
    }
  }

void BitClkPLLinit(){
  ClkPLLearly=0 ;
  ClkPLLlate=0 ;
  ClkPLLcount=0 ;
  ClkPLLcorrection=0 ;
  }


//----------------------------------------------------------------------------------------  
int clkDDSphase ;
int clkDDSfrequency ;

float IIRfil1=0.0 ;



float RDSval=0.0 ;
inline void RDSsample(int RDSval2){
  RDSval=0.3*RDSval+0.7*RDSval2 ;

  BitClkPLL(RDSval) ;
  RDStimeAsInt++ ;
  lastRDStime=RDStime ;
  RDStime += ( sampleTime2+ClkPLLcorrection ) ; 
  ClkPLLcorrection=0 ;
  if( RDStime > RDSperiod ){ 
    RDStime-=RDSperiod ;
    RDStimeAsInt=0 ; 
    }
  scope(RDSval) ;
  }

void RDSinit(){
  ClkPLLcorrection=0 ;
  RDStime=0 ;
  RDStimeAsInt=0 ;
  xRDSsample=0 ;
  lastSample=0 ;
  restartRsyndrom() ;
  BitClkPLLinit() ;
  }

int nextFifoChk=0 ;

uint8_t u=0 ;

void doIQsample(){
  int Isample=IntFifoI[IntFifoOutPtr] ;
  int Qsample=IntFifoQ[IntFifoOutPtr] ;
  IntFifoOutPtr=(IntFifoOutPtr+1) & IntFifoMask ;
 
  pwm_set_gpio_level(PWM_PIN1, 250+Isample/10 );
  pwm_set_gpio_level(PWM_PIN2, 250+Qsample/10 );

  //pwm_set_gpio_level(PWM_PIN2, 312+rdsVCO/100 );
  //pwm_set_gpio_level(PWM_PIN2, 312+costas1/2000 );
  
  //pwm_set_gpio_level(PWM_PIN2, 312+clk/10 );
   //pwm_set_gpio_level(PWM_PIN2, 312+20*RDStimeAsInt );

  //costas1=0.99999*costas1+0.00001*Isample*Qsample ;

   //costas1=0.999*costas1+0.0005*Isample*Qsample ;
  //  costas1=0.999*costas1+0.005*Isample*Qsample ;
    costas1=0.9999*costas1+0.005*Isample*Qsample ;

  rdsVCO=costasLoopGain*costas1 ;
  //rdsVCO=0 ;

  RDSsample(Isample) ;

  //pwm_set_gpio_level(PWM_PIN2, 62+inputVal/30 );
  
  }

double fSample ;

void PWMsetup(){    
  gpio_set_function(PWM_PIN1, GPIO_FUNC_PWM);
  gpio_set_function(PWM_PIN2, GPIO_FUNC_PWM);
  // Figure out which slice we just connected to the pin
  uint slice_num1 = pwm_gpio_to_slice_num(PWM_PIN1);
  uint slice_num2 = pwm_gpio_to_slice_num(PWM_PIN2);
  // Mask our slice's IRQ output into the PWM block's single interrupt line,
  // and register our interrupt handler
  pwm_clear_irq(slice_num1);
  pwm_set_irq_enabled(slice_num1, true);
  irq_set_exclusive_handler(PWM_IRQ_WRAP, on_pwm_wrap);
  irq_set_enabled(PWM_IRQ_WRAP, true);
  // Get some sensible defaults for the slice configuration. 
  pwm_config config1 = pwm_get_default_config();
  pwm_config config2 = pwm_get_default_config();
  // Set divider, reduces counter clock to sysclock/this value
  pwm_config_set_clkdiv(&config1, 1.f);
  pwm_config_set_clkdiv(&config2, 1.f);
  // Load the configuration into our PWM slice, and set it running.
  pwm_init(slice_num1, &config1, true);
  pwm_init(slice_num2, &config2, true);
  // Set period of 125 cycles (0 to 124 inclusive)
  //pwm_set_wrap(slice_num1,124 );
  //#define clkDiv 125
  //#define clkDiv 625
  #define clkDiv 500
  pwm_set_wrap(slice_num1,(clkDiv-1) );
  pwm_set_wrap(slice_num2,(clkDiv-1) );
  fSample=125e6/clkDiv/1.0 ;
  printf("fSample=%15.5f\n",fSample) ;
  printf("PWM_PIN1=%d\n",PWM_PIN1) ;
  printf("slice_num1=%d\n",slice_num1) ;
  printf("config1=%d\n",config1) ;
  printf("\n") ;
  printf("PWM_PIN2=%d\n",PWM_PIN2) ;
  printf("slice_num2=%d\n",slice_num2) ;
  printf("config2=%d\n",config2) ;
  }

void abort2(){
  printf("abort..\n") ;
  printf("\n") ;
  while(1){} ;
  }

int main() {
  stdio_init_all();
  gpio_init(GPIO4);
  gpio_set_dir(GPIO4, GPIO_OUT);

  IntFifoInit() ;
  PWMsetup() ;
 
  tftSetup() ;
  termInit() ;
  eyeInit() ;

  //approxSleepMs(200);
  printf("//\n") ;
  printf("//\n") ;
  printf("Hello  !\n") ;
  
  toggle=0 ;
  
  printf("fSample=%15.5f\n",fSample) ;
  adc_init();
  // Make sure GPIO is high-impedance, no pullups etc

  //adc_gpio_init(26);
  // Select ADC input 0 (GPIO26)
  //adc_select_input(0);

// Select ADC input 2 (GPIO28)
  adc_gpio_init(28);
  adc_select_input(2);

 for(int k=0 ; k<4096 ; k++){
    DDStable[k]=2000.0*sin(2.0*M_PI*k/4096.0) ;
    }
  printf("here 2...\n") ;
  DDSphase=0 ;
  DDSfrequencyBase=LOfrequency/fSample*(double)(0x100000000L) ;
  int testOffsetFrequency=LOoffset/fSample*(double)(0x100000000L) ;
  DDSfrequencyBase += testOffsetFrequency ;
  DDSfrequencyVCO=0 ;
  DDSfrequency=DDSfrequencyBase+DDSfrequencyVCO ;

  clkDDSfrequency=1187.5/10000.0*(double)(0x100000000L) ; ;

/*
  int k ;
  while(1){
    k=0 ;
    while(k<4096) {  
       int pwm=312+DDStable[k]/8 ;
       pwm_set_gpio_level(PWM_PIN1, pwm );
       pwm_set_gpio_level(PWM_PIN2, pwm );
       k+=8 ;
       sleep_us(10) ;
       }
    }
*/

 
  setupTables() ;
  RDSinit() ;

  GTfifoInit() ;
  multicore_launch_core1(core1_entry);

  // Everything after this point happens in the PWM interrupt handler, so we
  // can twiddle our thumbs

  // approxSleepUsTest() ;
  int jj=0 ;
  while (1){
    if( IntFifoInPtr != IntFifoOutPtr ){
    //  gpio_put(GPIO3, 1);
	doIQsample() ;
    //  gpio_put(GPIO3, 0);
      jj++ ;
      if(jj>10000){
        jj=0 ;
       // printf("i=%12d q=%12d vco=%8d %10.3f\n", FrontendFilterII, FrontendFilterQQ ,rdsVCO, costas1)  ;
        }

      }
    }
  }

