#define GPIO5 5     // pin 7    
#define GPIO3 3     // pin 5   
#define PWMgpio6 6    // GPIO6 pin 9

//float yysampleFrequency ;

#define ADCbufSize 15200

int ADCbuf1[ADCbufSize] ;
int ADCbuf2[ADCbufSize] ;
volatile int ADCbufPtr ;

volatile int16_t result1 ;
volatile int16_t result2 ;

void gpioCallback() {
  gpio_put(GPIO4, 1);

  adc_select_input(1);
  result1 = adc_read();

  adc_select_input(2);
  result2 = adc_read();

  if(ADCbufPtr<ADCbufSize) {
    ADCbuf1[ADCbufPtr]=result1 ;
    ADCbuf2[ADCbufPtr]=result2 ;
    ADCbufPtr++ ;
    }
  gpio_put(GPIO4, 0);
  }

void yyPWMsetup(){
  #define PWMclkDiv 1.0f    
  #define PWMwrap 1000
  gpio_set_function(PWMgpio6, GPIO_FUNC_PWM);
   // Figure out which slice we just connected to the pin
  uint yyslice_num1 = pwm_gpio_to_slice_num(PWMgpio6);
    // Get some sensible defaults for the slice configuration. 
  pwm_config yyconfig1 = pwm_get_default_config();
  // Set divider, reduces counter clock to sysclock/this value
  pwm_config_set_clkdiv(&yyconfig1, PWMclkDiv);
  // Load the configuration into our PWM slice, and set it running.
  pwm_init(yyslice_num1, &yyconfig1, true);
  pwm_set_wrap(yyslice_num1,(PWMwrap-1) );
  printf("cpuKlkKhz=%10d kHz\n",cpuClkKhz) ;
  fSampleADC=cpuClkKhz*1e3/PWMwrap/PWMclkDiv ;
  printf("fSampleDAC=%15.5f\n",fSampleADC) ;

  pwm_set_gpio_level(PWMgpio6, 100);
 
  printf("PWMgpio6=%d\n",PWMgpio6) ;
  printf("yyslice_num1=%d\n",yyslice_num1) ;
  printf("yyconfig1=%d\n",yyconfig1) ;
  printf("\n") ;
  }



void core1_entry() {
  printf("Hello, multicore core1_entry()!\n");

  gpio_init(GPIO5);
  gpio_set_dir(GPIO5, GPIO_OUT);

  gpio_init(GPIO3);
  gpio_set_dir(GPIO3, GPIO_IN);

  yyPWMsetup() ;

  gpio_set_irq_enabled_with_callbackOssi(3, GPIO_IRQ_EDGE_RISE , true, &gpioCallback);

/*
  while(1){
    gpio_put(GPIO5, 1);
    asm volatile("nop"); asm volatile("nop"); asm volatile("nop");
    gpio_put(GPIO5, 0);
    asm volatile("nop"); asm volatile("nop"); asm volatile("nop");
    }
*/

  while(1){
    tight_loop_contents();
    }
 
  }
