#include <stdio.h>
#include "pico/stdlib.h"

#include <math.h>
#include <stdlib.h>



void uartPutc( char c){
   printf("%c",c) ;            
   }

uint8_t uartGetc(void){
  uint8_t cc = getc(stdin);
   return cc ;                   
}


void uartBlank(){
  uartPutc(' ') ; 
  }

void uartCrlf(){
  uartPutc(13) ; 
  uartPutc(10) ;
  }

void uartLf(){
  uartPutc(13) ; 
  }

void uartDecOut(int k){
  uartPutc( ((k/10000) % 10)+48 ) ;
  uartPutc( ((k/1000) % 10)+48 ) ;
  uartPutc( ((k/100) % 10)+48 ) ;
  uartPutc( ((k/10) % 10)+48 ) ;
  uartPutc( (k % 10)+48 ) ;
  uartPutc(32) ;
  }

void uartDecOut32(int32_t k){
  uartPutc( ((k/100000000UL) % 10)+48 ) ;
  uartPutc( ((k/10000000UL) % 10)+48 ) ;
  uartPutc( ((k/1000000UL) % 10)+48 ) ;
  uartPutc( ((k/100000UL) % 10)+48 ) ;
  uartPutc( ((k/10000UL) % 10)+48 ) ;
  uartPutc('.') ; 
  uartPutc( ((k/1000UL) % 10)+48 ) ;
  uartPutc( ((k/100UL) % 10)+48 ) ;
  uartPutc( ((k/10UL) % 10)+48 ) ;
  uartPutc( (k % 10UL)+48 ) ;
  uartPutc(32) ;
  }

uint16_t uartGetDecimal(){
	uint16_t c ;
	uint16_t v ;
	v=0 ;
	printf("getDec>>") ;
	while(1){
		c=uartGetc() ;
		if ( ('0'<=c) & (c<='9') ) { v=10*v + (c-'0') ; 	uartPutc(c) ;}
		else { uartBlank() ; return(v) ; }
		} ;

}

void SerTest1(){
   int k=0 ; 
   while(1){
      printf("hello rxOM5610pico1V01 k=%d\n",k++) ;
      sleep_ms(500) ;
      }
  }

void SerTest2(int kMax){
   int k=0 ; 
   while(k<kMax){
      printf("hello rxOM5610pico1V01 k=%d\n",k++) ;
      sleep_ms(500) ;
      }
  }

void serIOtest1(){
   printf("serIOtest1()...\n") ;
   while(1){
    //while(!uart_is_readable(uart0)){}
    //int cc=uart_getc(uart0) ;

    int cc = getc(stdin);
    printf("[%02x]",cc) ;

   }
  }


#define OM5610data 15
#define OM5610clock 14
#define OM5610wren 13

void delayOM5610(){
  sleep_us(20) ;
  }

#define MASK24 0x1000000 // bit 24 set

void om5610CLK(){
	gpio_put(OM5610clock, 1);
    delayOM5610() ;
    gpio_put(OM5610clock, 0);
    delayOM5610() ;
    }

void sndOM5610(uint32_t sReg){
    int nFrq=sReg ;
	/*
	uint32_t n1=125UL*((uint32_t)nFrq) ;
	n1=n1-107000UL ;
	printf("sndOM5610 nFrq=%d   frq=",nFrq) ;
    uartDecOut32(n1) ;
    printf("\n") ;
  */
  gpio_set_dir(OM5610data, GPIO_OUT);
  gpio_put(OM5610wren, 1);
  delayOM5610() ;
  //sReg|=0x110000 ;

  for(uint8_t k=0 ; k<25 ; k++){
    if(sReg & MASK24 ){ 
       gpio_put(OM5610data, 1) ; 
       //printf("_1") ; 
       }
      else { 
       gpio_put(OM5610data, 0) ; 
       // printf("_0") ; 
       }
	sReg = sReg << 1 ;
	om5610CLK() ;
    }
  gpio_put(OM5610data, 1) ;
  gpio_put(OM5610wren, 0);

  //sleep_ms(2000) ;
   sleep_ms(20) ;

 
  gpio_set_dir(OM5610data, GPIO_IN);
  gpio_pull_up(OM5610data);


  int mask=MASK24 ;
  int rxData=0 ;
  for(int k=0 ; k<24 ; k++){
    mask=mask>>1 ;
    om5610CLK() ;
    if(gpio_get(OM5610data)){ 
      rxData |= mask ; 
      }
    }
  sleep_us(100) ;
  gpio_set_dir(OM5610data, GPIO_OUT);
  printf("rxData=%08x  ",rxData ) ;
  int nnFrq=rxData ;
  int n1=125*(nnFrq) ;
  n1=n1-107000 ;
  float fn1=n1/10000.0 ;
  printf("frq=%10.4f\n",fn1) ;
  //println(n1/10000,".",n1 % 10000," MHz") ;
  }





  

void initOM5610(){
  gpio_put(OM5610data, 0);
  gpio_put(OM5610clock, 0);
  gpio_put(OM5610wren, 0);
  }

void runOm5610(){
  printf("Run OM5610") ;
  initOM5610() ;
  sndOM5610(8368) ;
  sndOM5610(8368) ;
  //mode2(OM5610) ;
  }

void testOM5610_1(){
  while(1){
    //sndOM5610(8368) ; // 93.9 WDR4
    //sndOM5610(9008) ; // 101.9 WDR5
    //sndOM5610(9368) ; // 106.4 1 Live
    //sndOM5610(8528) ; // 95.9 WDR3
    //sndOM5610(8920) ; // 100.8 WDR2

   // sndOM5610( 8864 ) ; // 100.1 antenne ac
     sndOM5610( 9072 ) ; // 102.7 DLF
    }
  }


void mode2(){
  uint16_t nFrq=8920 ;
  nFrq=8368 ; // 39.9 WDR4
 // nFrq=8096 ;
 // nFrq=8048 ; // 89.9
  uint16_t dF=8 ;
  while(1){
    sndOM5610(nFrq) ;
  /*
  	uartDecOut(nFrq) ;
	  uartPutc(' ') ;
	  uint32_t n1=125UL*((uint32_t)nFrq) ;
	  n1=n1-107000UL ;
	  uartDecOut32(n1) ;
    */
	  uartCrlf() ;
    char c=uartGetc() ;
    printf("c=[%02x] ",(int)c) ;
	  if (c=='+'){ nFrq += dF ; }
	  if (c=='-'){ nFrq -= dF ; }
	  if (c=='a'){ nFrq += 1 ; }
	  if (c=='b'){ nFrq -= 1 ; }
    if (c=='n'){ nFrq =uartGetDecimal() ; }
    }
  }


int main()
{
    stdio_init_all();


    gpio_init(OM5610data );
    gpio_set_dir(OM5610data, GPIO_OUT);
    gpio_init(OM5610clock );
    gpio_set_dir(OM5610clock, GPIO_OUT);
    gpio_init(OM5610wren );
    gpio_set_dir(OM5610wren, GPIO_OUT);

   


    printf("\n\nHello, world rxOM5610pico2V01 !\n");
    SerTest2(10) ;
  //  serIOtest1() ;


    runOm5610() ;
  //  testOM5610_1() ;
    mode2() ;

    printf("abort") ;
    while(1){} ;
    return 0;
}
