
#include "pico/stdlib.h"
#include <stdio.h>
#include <math.h>

#include "pico/time.h"
#include "hardware/irq.h"
#include "hardware/structs/adc.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_pwm\include\hardware\pwm.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_adc\include\hardware\adc.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_gpio\include\hardware\gpio.h>
//#include "hardware/adc.h"

#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_sync\include\hardware\sync.h>

#include "hardware/resets.h"

#define PWM_PIN1 2
#define PWM_PIN2 3

#define GPIO4 4
int toggle ;

#define PWMclkDiv 500
#define nDown 1000
#define fSampleADC 500000
 #define DDSfrq (162000.0-0.5)
//  #define DDSfrq 162000.0 

uint32_t DDSp ; // DDS phase value
uint32_t DDSd ; // DDS phase delta

int LOsinTab[256] ;
int LOcosTab[256] ;

int demodFil ;
int IIfil ;
int QQfil ;

//-----------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------

#define tftOn 1

// Color definitions
#define ILI9341_BLACK       0x0000      /*   0,   0,   0 */
#define ILI9341_NAVY        0x000F      /*   0,   0, 128 */
#define ILI9341_DARKGREEN   0x03E0      /*   0, 128,   0 */
#define ILI9341_DARKCYAN    0x03EF      /*   0, 128, 128 */
#define ILI9341_MAROON      0x7800      /* 128,   0,   0 */
#define ILI9341_PURPLE      0x780F      /* 128,   0, 128 */
#define ILI9341_OLIVE       0x7BE0      /* 128, 128,   0 */
#define ILI9341_LIGHTGREY   0xC618      /* 192, 192, 192 */
#define ILI9341_DARKGREY    0x7BEF      /* 128, 128, 128 */
#define ILI9341_BLUE        0x001F      /*   0,   0, 255 */
#define ILI9341_GREEN       0x07E0      /*   0, 255,   0 */
#define ILI9341_CYAN        0x07FF      /*   0, 255, 255 */
#define ILI9341_RED         0xF800      /* 255,   0,   0 */
#define ILI9341_MAGENTA     0xF81F      /* 255,   0, 255 */
#define ILI9341_YELLOW      0xFFE0      /* 255, 255,   0 */
#define ILI9341_WHITE       0xFFFF      /* 255, 255, 255 */
#define ILI9341_ORANGE      0xFD20      /* 255, 165,   0 */
#define ILI9341_GREENYELLOW 0xAFE5      /* 173, 255,  47 */
#define ILI9341_PINK        0xF81F

int chrColor = ILI9341_WHITE ; 
int chrBackground = ILI9341_BLACK ; 
int xLast=0 ;
int yLast=0 ;



static void approxSleepUs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<5 ; kk++){
      asm volatile("nop");
      }
    }
  }
  
static void approxSleepMs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<10 ; kk++){
      approxSleepUs(1000) ;
      }
    }
  }

static volatile void approxSleepUsTest(){
  printf("atleastSleepUsTest()\n") ;
  save_and_disable_interrupts() ;
  while(1){
    sio_hw->gpio_set =(1ul << GPIO4) ;  
	  approxSleepUs(1000) ;
    //sleep_ms(1) ;
    sio_hw->gpio_clr =(1ul << GPIO4) ;  
    approxSleepUs(1000) ;
  //  printf(".") ;
  }
} 

#include "tftLib1.c"

//-----------------------------------------------------------------------------------


//-----------------------------------------------------------------------------------

#define maxsec 50 
#define maxfil 10 

float a0[maxfil]  ;
int secstart[maxfil] ;
int seccnt[maxfil] ;

float w1[maxsec] ;

float w2[maxsec] ;
float a1[maxsec] ;
float a2[maxsec] ;
float b1[maxsec] ;
float b2[maxsec] ;
int filtop=0 ;
int sectop=0  ;

int butter(int nord, float frq){
int i,nsec ; 
float a0x,eps,a,b,s1,s2,t,c1,w,ww,u,v,d ;

if ((nord % 2)!=0){ printf("nord wrong in Tscheby") ; }
filtop++ ;
if( filtop>maxfil){ printf("maxfil error") ; }
nsec=nord / 2 ;
secstart[filtop]=sectop+1 ;
seccnt[filtop]=nsec ;
printf("butterworth filter, no=%d\n",filtop) ;
printf("ord=%d number of sections is %d\n",nord,nsec) ;
a0x=1.0 ;
for( i=nord ; i< 3*nsec ; i++){
  t=(2.0*i+1.0)/(2.0*nord)*M_PI ;
  c1=M_PI*frq ;
  w=sin(c1)/cos(c1) ;
  printf("t=%10.4f  w=%10.4f\n",t,w) ;
  ww=w*w ;
  b=2*w ;
  d=1-b*cos(t)+ww ;
  u=(1-ww)/d ;
  v=b*sin(t)/d ;
  sectop++ ;
  b1[sectop]=-2*u ;
  b2[sectop]=u*u+v*v ;
  printf("b1=%10.4f b2=%10.4f\n",b1[sectop],b2[sectop]) ;
  a1[sectop]=2 ; 
  a2[sectop]=1 ;
  a0x=a0x*(1-2*u+u*u+v*v)/4 ;
  }
printf("a0=%10.4f\n",a0x) ;
a0[filtop]=a0x ;
return filtop ;
}

void tpreset(int filno){ 
  int i ;
  printf("reset filter with no=%d\n",filno) ;
  for (i=secstart[filno] ; i<secstart[filno]+seccnt[filno] ; i++){
  w1[i]=0 ; 
  w2[i]=0 ; 
  printf("clear section %d\n",i) ;
  }
}

float tprun(int filno, float x){
  int i ; 
  float w,w11,w22,y ;
  for(i=secstart[filno] ; i< secstart[filno]+seccnt[filno] ; i++){
    w11=w1[i] ; w22=w2[i] ;
    w=x-b1[i]*w11-b2[i]*w22 ;
    y=w+a1[i]*w11+a2[i]*w22 ;
    w2[i]=w11 ; w1[i]=w ; x=y ;
    }
  return a0[filno]*y ;
  }

//---------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
#define scopeXsize 480
#define scopeYsize 200
#define scopeX0 2
#define scopeY0 2
#define scopeColor  ILI9341_WHITE 
#define scopeBackground  ILI9341_DARKGREEN 

int scopeX ;
int scopeYi1[scopeXsize] ;
int scopeYi2[scopeXsize] ;
int theColor ;

void scopeInit(){
  tftRectf(scopeX0, scopeY0, scopeXsize, scopeYsize, scopeBackground ) ;
  scopeX=0 ;
  for(int k=0 ; k<scopeXsize ; k++){
    scopeYi1[k]=0 ;
    scopeYi2[k]=0 ;
    }
  }

void doScope(int y1, int y2){
  static int lastY1=0 ;
  static int lastY2=0 ;
  if(y1<0){ y1=0 ; }
  if(y1>=scopeYsize){ y1=scopeYsize-1 ; }
  y1 += scopeY0 ;

  if(y2<0){ y2=0 ; }
  if(y2>=scopeYsize){ y2=scopeYsize-1 ; }
  y2 += scopeY0 ;


  if(scopeX>0){
    tftLine(scopeX0+scopeX-1,lastY1,scopeX0+scopeX,scopeYi1[scopeX],scopeBackground) ;
    tftLine(scopeX0+scopeX-1,scopeYi1[scopeX-1],scopeX0+scopeX,y1,theColor) ;

    tftLine(scopeX0+scopeX-1,lastY2,scopeX0+scopeX,scopeYi2[scopeX],scopeBackground) ;
    tftLine(scopeX0+scopeX-1,scopeYi2[scopeX-1],scopeX0+scopeX,y2,theColor) ;

    }
  lastY1=scopeYi1[scopeX] ;
  scopeYi1[scopeX]=y1 ;

  lastY2=scopeYi2[scopeX] ;
  scopeYi2[scopeX]=y2 ;

  scopeX++ ;
  if(scopeX>=scopeXsize){ scopeX=0 ; }
  }

//------------------------------------------------------------------------------------------------------

void uartPutc(char c){
  printf("%c",c) ;
  }

void uartPrint (char *s){
  while (*s){   
    uartPutc(*s);
    s++;
    }
  }

void uartBlank(){
  uartPutc(' ') ; 
  }

void uartCrlf(){
  uartPutc(13) ; 
  uartPutc(10) ;
  }

void uartCr(){
  uartPutc(13) ; 
  uartPutc(10) ;
  }

void decout(int k){
  // uartPutc(32) ;
  uartPutc( ((k/1000) % 10)+48 ) ;
  uartPutc( ((k/100) % 10)+48 ) ;
  uartPutc( ((k/10) % 10)+48 ) ;
  uartPutc( (k % 10)+48 ) ;
  uartPutc(32) ;
  }

void chr_out(uint8_t v){
  uartPutc(v) ; 
  }

void hex_out(uint8_t v){
  v &=0b00001111 ;
  if (v<=9) { chr_out('0'+v) ; } 
    else { chr_out(v+'A'-10) ; } ;
  }

void byte_out(uint8_t v){
  hex_out(v>>4) ; 
  hex_out(v) ; 
  }

void word_out(uint16_t v){
  byte_out(v>>8) ; 
  byte_out(v) ; 
  }

//------------------------------------------------------------------------------------------------------

int sampleTime=0 ;
int Isum,Qsum ;
static volatile int Ival,Qval ;

#define IntFifoSize 32768
#define IntFifoMask (32768-1)

volatile int IntFifoInPtr ;
volatile int IntFifoOutPtr ;
volatile int16_t IntFifoI[IntFifoSize] ;
volatile int16_t IntFifoQ[IntFifoSize] ;

void IntFifoInit(){
  IntFifoInPtr=0 ;
  IntFifoOutPtr=0 ;
  }

int inputVal ;
int pwm=0 ;

void on_pwm_wrap() {
  gpio_put(GPIO4, 1);
  pwm_clear_irq(pwm_gpio_to_slice_num(PWM_PIN1));
  while(adc_fifo_get_level()){
    DDSp += DDSd ; 
    inputVal=(adc_fifo_get()-2048) ;
    Isum += LOsinTab[DDSp>>24]*inputVal ;
    Qsum += LOcosTab[DDSp>>24]*inputVal ;
    sampleTime++ ;
    if(sampleTime>=nDown){ 
      Ival=Isum/256 ; 
      Qval=Qsum/256 ;
      Isum=0 ;
      Qsum=0 ;
      sampleTime=0 ;
      IntFifoI[IntFifoInPtr]=Ival ;
      IntFifoQ[IntFifoInPtr]=Qval ;
      IntFifoInPtr=(IntFifoInPtr+1) & IntFifoMask ;
      }
    }  
  gpio_put(GPIO4, 0);
  }

//
//-------------------------------------------------------------------------------------
//
int Phase ;
int LastPhase ;
int PhaseDifference ;
int FrequencyEstimate ;
short ExtendedPhase=0 ;  

#define FRQlength 8 
int FRQdivider=1 ;

int FRQfifo[FRQlength] ;
int FRQintegrator=0 ;
int FRQcicout=0 ;
int FRQfifoPTR=0 ;

int xx=0 ;
int xxLast=0 ;
int yy=0 ;
int yyLast=0 ;
// color yyColor ;
  
int cnt3=0 ;
int cnt2 ;

int SilenceTimer ;
float SecondTimer ;
int x0,x1,x2,Frequency ;

float THRESHOLD1=500 ;

void DisplayTime() ;
void putDCFbit(int TheSecond , int TheBit) ;


  
#define TDFlength 50 

int TDFbuffer[TDFlength] ;
int TDFintegrator ;

int TDFptr ;
int ptr ;

int TheSecond ;
int TheBit ;
  
void TDFinit(){
  TDFptr=0 ;
  TheSecond=0 ;
  TDFintegrator=0 ;
  ptr=0 ;
  }

void demodInit(){
  TDFinit() ;
  }  
  
void advance(int d){  
  ptr += d ;
  if ( ptr >= TDFlength ) { ptr -= TDFlength ; }
  }

int MatchedFilter(int Frequency){
  int sum ;
  // CIC implementation of matched filter
  ptr=TDFptr ;
  // ptr points to oldest sample in TDFbuffer
  sum=-TDFbuffer[ptr] ;
  advance(12) ;
  sum += 2*TDFbuffer[ptr] ;
  advance(25) ;
  sum -= 2*TDFbuffer[ptr] ;
  advance(12) ;
  sum +=   TDFbuffer[ptr] ;

  TDFintegrator += Frequency ;
  // replace oldest sample in buffer
  TDFbuffer[TDFptr]=TDFintegrator ;
  TDFptr++ ;
  if ( TDFptr==TDFlength) {
    TDFptr=0 ;
    }
  return sum ;
  }
  


void searchForPeak(){
  if ( ( x1>=x0 ) && (x1>x2) && (x1>THRESHOLD1) ) { 
    SecondTimer=0 ; 
    SilenceTimer=0 ;
    TheSecond=0 ;
    DisplayTime() ;
    }
  }
  
void checkForGap(){
  SilenceTimer++ ;
  if ( ( x1>THRESHOLD1 ) & ( SilenceTimer<390) )  { 
    SilenceTimer=0 ; }
  if ( SilenceTimer>400 ) {
    SilenceTimer=400 ;
    //println("gap found") ;
    searchForPeak() ;
    }
  }
    
void checkSecondTimer(){
  SecondTimer += (1.00-0.0002) ;
  if (SecondTimer>=500.0) {
    SecondTimer-=500.0 ; 
    }
  if (((int)SecondTimer)==45){
     theColor=ILI9341_RED ;
     }
  if (((int)SecondTimer)==55){
     theColor=ILI9341_WHITE ;
     }

  if (((int)SecondTimer)==50){
    if ( x1>THRESHOLD1 ) { 
      TheBit=1 ; 
      }
     else {
      TheBit=0 ;
      }
    printf("%d",TheBit) ;
       
    if(TheSecond>61){
      printf(" gap error! ") ;
      TheSecond=0 ;
      }
    putDCFbit(TheSecond,TheBit) ;
    TheSecond++ ;
    }
  }
  
#define EE 256  
 
void FMdemod(float II, float QQ){
 
  float phi=-atan2(II,QQ) ;
  Phase=((int)( (phi+M_PI)/M_PI*128)) & 0xFF ;
  PhaseDifference=(Phase-LastPhase) ;

  if(PhaseDifference>128){ PhaseDifference -= 256 ; }
  if(PhaseDifference<-128){ PhaseDifference +=256 ; }




  LastPhase=Phase ;
  ExtendedPhase += PhaseDifference ;
  if( ExtendedPhase>EE){ ExtendedPhase-=2*EE ; }
  if( ExtendedPhase<-EE){ ExtendedPhase+=2*EE ; }

  FrequencyEstimate = PhaseDifference ;
  //analogWrite(PWMpinA, Phase);
  // analogWrite(PWMpinA, 128+PhaseDifference);
  // filter the frquency-signal with a CIC filter
  FRQintegrator += FrequencyEstimate ;
  FRQcicout = FRQintegrator - FRQfifo[FRQfifoPTR] ;
  FRQfifo[FRQfifoPTR] =  FRQintegrator ;
// advance pointer and bump around
  FRQfifoPTR++ ; if ( FRQfifoPTR==FRQlength ) { FRQfifoPTR=0 ; }

  Frequency=FRQcicout ;
  x2=x1 ; x1=x0 ; x0=MatchedFilter(-Frequency) ;
  //if(x0> THRESHOLD1){ yyColor=color(255,0,0) ; } else { yyColor=color(0,255,255) ; }
  //if(x0<-THRESHOLD1){ yyColor=color(0,255,100) ; } 
  checkForGap() ;
  checkSecondTimer() ;

  
  }





//----------------------------------------------------------------------------------------  
int TheBits[60] ;

void putDCFbit(int TheSecond , int TheBit){
  if (TheSecond<60) { TheBits[TheSecond]=TheBit ; }
  }

int ParityBit,P1,P2,P3 ;

int getBCD(int BitPos , int BitCount){
  int value ;
  int k,q ;
  value=0 ;
  q=1 ;
  for (k=0 ; k<BitCount ; k++ ) { 
    if ( TheBits[BitPos++]>0 ) { value += q ; ParityBit ^= 1 ; }
    q=2*q ;
    }
  return value ;
  }


void DisplayTime(){
  int min1 ;
  int min10 ;
  int hrs1 ;
  int hrs10 ;
  int day1 ;
  int day10 ;
  int month1 ;
  int month10 ;
  int weekday ;
  int year1 ;
  int year10 ;

 
  ParityBit=0 ;
  min1=getBCD(21,4) ;
  min10=getBCD(25,3) ;
  P1=ParityBit ^ TheBits[28] ;

  ParityBit=0 ;       
  hrs1=getBCD(29,4) ;
  hrs10=getBCD(33,2) ;
  P2=ParityBit ^ TheBits[35] ;
           
  ParityBit=0 ;     
  day1=getBCD(36,4) ;
  day10=getBCD(40,2) ;
  weekday=getBCD(42,3) ;
  month1=getBCD(45,4) ;
  month10=getBCD(49,1) ;
  year1=getBCD(50,4) ;
  year10=getBCD(54,4) ;
  P3=ParityBit ^ TheBits[58] ;

  uartPutc('#') ; for(int k=50 ; k<58 ; k++){ uartPutc('0'+TheBits[k]) ; }
  uartPutc(':') ;  
  uartPutc(' ') ;  
 
  uartPutc('0'+hrs10) ;
  uartPutc('0'+hrs1) ;
  uartPutc(':') ;
  uartPutc('0'+min10) ;
  uartPutc('0'+min1) ;
  uartBlank() ;
  uartPutc('0'+day10) ;
  uartPutc('0'+day1) ;
  uartPutc('.') ;

  uartPutc('0'+month10) ;
  uartPutc('0'+month1) ;
  uartPutc(' ') ;
  
  if ( weekday==1) {  uartPrint(  "MONDAY   ") ; }  
  if ( weekday==2) {  uartPrint(  "TUESDAY  ") ; }
  if ( weekday==3) {  uartPrint(  "WEDNESDAY") ; }
  if ( weekday==4) {  uartPrint(  "THURSDAY ") ; }
  if ( weekday==5) {  uartPrint(  "FRIDAY   ") ; }
  if ( weekday==6) {  uartPrint(  "SATURDAY ") ; }
  if ( weekday==7) {  uartPrint(  "SUNDAY   ") ; }
  uartBlank() ;
  uartPutc('2') ;
  uartPutc('0') ;
  uartPutc('0'+year10) ;
  uartPutc('0'+year1) ;
  uartBlank() ;
  uartPutc('p') ;
  uartPutc('0'+P1) ;
  uartPutc('0'+P2) ;
  uartPutc('0'+P3) ;
    
  uartCrlf() ; 


  termXpos=1 ;
  termYpos=2 ;
 termPutc('0'+hrs10) ;
  termPutc('0'+hrs1) ;
  termPutc(':') ;
  termPutc('0'+min10) ;
  termPutc('0'+min1) ;
  termPutc(' ') ;
  termPutc('0'+day10) ;
  termPutc('0'+day1) ;
  termPutc('.') ;

  termPutc('0'+month10) ;
  termPutc('0'+month1) ;
  termPutc(' ') ;
  
  if ( weekday==1) {  termPrint(  "MONDAY   ") ; }  
  if ( weekday==2) {  termPrint(  "TUESDAY  ") ; }
  if ( weekday==3) {  termPrint(  "WEDNESDAY") ; }
  if ( weekday==4) {  termPrint(  "THURSDAY ") ; }
  if ( weekday==5) {  termPrint(  "FRIDAY   ") ; }
  if ( weekday==6) {  termPrint(  "SATURDAY ") ; }
  if ( weekday==7) {  termPrint(  "SUNDAY   ") ; }
  termPutc(' ') ;
  termPutc('2') ;
  termPutc('0') ;
  termPutc('0'+year10) ;
  termPutc('0'+year1) ;
  termPutc(' ') ;
  termPutc('p') ;
  termPutc('0'+P1) ;
  termPutc('0'+P2) ;
  termPutc('0'+P3) ;
  }  

//
//-------------------------------------------------------------------------------------
//

int CICfifoQout ;
int CICfifoIout ;

char indexChar='A' ;
int jj ;

void doIQsample(){
  int Isample=IntFifoI[IntFifoOutPtr] ;
  int Qsample=IntFifoQ[IntFifoOutPtr] ;
  IntFifoOutPtr=(IntFifoOutPtr+1) & IntFifoMask ;

/*
 uartPutc('s') ;
  if(indexChar<'Z') { indexChar++ ;} else { indexChar='A' ; }
  uartPutc(indexChar) ;
  word_out(Isample) ;
  word_out(Qsample) ;
  uartCrlf() ;
*/

  CICfifoQout = tprun(QQfil,Qsample)/250 ; 
  CICfifoIout = tprun(IIfil,Isample)/250 ; 
  FMdemod(CICfifoIout,CICfifoQout) ;

  
 // pwm_set_gpio_level(PWM_PIN1, 125+2*CICfifoIout );
 // pwm_set_gpio_level(PWM_PIN2, 125+2*CICfifoQout );
 
 //printf("IQ=%8d %8d\n",CICfifoIout,CICfifoQout) ;
 // printf("IQ=%8d %8d\n",Ival,Qval) ;

  pwm_set_gpio_level(PWM_PIN1, 250+10*FrequencyEstimate );
  //pwm_set_gpio_level(PWM_PIN2, 250+ExtendedPhase);
  pwm_set_gpio_level(PWM_PIN2, 2+2*Phase);

  //doScope(50+x1/40,150+2*FrequencyEstimate) ;
   doScope(100+ExtendedPhase/4,150+2*FrequencyEstimate) ;
   //doScope(50+jj,150+2*FrequencyEstimate) ;
   jj++ ; if(jj>200){ jj=0 ; }
 //  pwm_set_gpio_level(PWM_PIN2, 250+10*FrequencyEstimate);
  }

double fPWM ;

void PWMsetup(){    
  gpio_set_function(PWM_PIN1, GPIO_FUNC_PWM);
  gpio_set_function(PWM_PIN2, GPIO_FUNC_PWM);
  // Figure out which slice we just connected to the pin
  uint slice_num1 = pwm_gpio_to_slice_num(PWM_PIN1);
  uint slice_num2 = pwm_gpio_to_slice_num(PWM_PIN2);
  // Mask our slice's IRQ output into the PWM block's single interrupt line,
  // and register our interrupt handler
  pwm_clear_irq(slice_num1);
  pwm_set_irq_enabled(slice_num1, true);
  irq_set_exclusive_handler(PWM_IRQ_WRAP, on_pwm_wrap);
  irq_set_enabled(PWM_IRQ_WRAP, true);
  // Get some sensible defaults for the slice configuration. 
  pwm_config config1 = pwm_get_default_config();
  pwm_config config2 = pwm_get_default_config();
  // Set divider, reduces counter clock to sysclock/this value
  pwm_config_set_clkdiv(&config1, 1.f);
  pwm_config_set_clkdiv(&config2, 1.f);
  // Load the configuration into our PWM slice, and set it running.
  pwm_init(slice_num1, &config1, true);
  pwm_init(slice_num2, &config2, true);
  // Set period of 250 cycles (0 to 249 inclusive)
 
  pwm_set_wrap(slice_num1,(PWMclkDiv-1) );
  pwm_set_wrap(slice_num2,(PWMclkDiv-1) );
  fPWM=125e6/PWMclkDiv/1.0 ;
  printf("\n\n") ;
  printf("fPWM       =%15.5f 1/s\n",fPWM) ;
  printf("fSampleADC =%15.5f 1/s\n",fSampleADC) ;
  printf("fSample2   =%15.5f 1/s\n",fSampleADC/nDown) ;

  printf("PWM_PIN1=%d\n",PWM_PIN1) ;
  printf("slice_num1=%d\n",slice_num1) ;
  printf("config1=%d\n",config1) ;
  printf("\n") ;
  printf("PWM_PIN2=%d\n",PWM_PIN2) ;
  printf("slice_num2=%d\n",slice_num2) ;
  printf("config2=%d\n",config2) ;
  }

int kDown ;

void abort(){
  printf("abort..\n") ;
  printf("\n") ;
  while(1){} ;
  }


void adcInit(void) {
  // ADC is in an unknown state. We should start by resetting it
  reset_block(RESETS_RESET_ADC_BITS);
  unreset_block_wait(RESETS_RESET_ADC_BITS);
  // Now turn it back on. Staging of clock etc is handled internally
  adc_hw->cs = ADC_CS_EN_BITS;
  // Internal staging completes in a few cycles, but poll to be sure
  while (!(adc_hw->cs & ADC_CS_READY_BITS)) {
    tight_loop_contents();
    }
  // Select ADC input 2 (GPIO28)
  adc_gpio_init(28);
  adc_select_input(2);
  adc_fifo_setup(true, false, 0, false, false);
  adc_run(true);
  // stop adc
  //adc_run(false);
  //adc_fifo_drain();
  }


int main() {
  stdio_init_all();
  gpio_init(GPIO4);
  gpio_set_dir(GPIO4, GPIO_OUT);

  approxSleepMs(200);
  printf("//\n") ;
  printf("//\n") ;
  printf("Hello TDFdecode162consoleToUartV01 !\n") ;

  tftSetup() ;
  cursorX=10 ;
  cursorY=300 ;
  tftPrint("Hello TFT!") ;
  termInit() ;

  scopeInit() ;

  IntFifoInit() ;
  PWMsetup() ;

  demodInit() ;
 
  int fil1=butter(6,0.2) ;
  tpreset(fil1) ;
  //abort() ;
  demodFil=butter(2,40.0/800.0) ;
  IIfil=butter(2,50.0/800.0) ;
  QQfil=butter(2,50.0/800.0) ;
  
  toggle=0 ;
   
 
  adcInit();
  

  for(int k=0 ; k<256 ; k++){
    double phi=2*M_PI*k/256.0 ;
    LOcosTab[k]=100*cos(phi) ;
    LOsinTab[k]=100*sin(phi) ;
    }

  DDSp =0 ;
  DDSd=(int)( 4294967296.0*DDSfrq/fSampleADC) ;
 
  //abort() ;

  kDown=0 ;
  while (1){
    kDown++ ;
    if(kDown=250000) {
      //printf("d=%10d\n",diff) ;
     // printf("f=%10d\n",frq) ;
      kDown=0 ;
      }
    if( IntFifoInPtr != IntFifoOutPtr ){
    //  gpio_put(GPIO4, 1);
	    doIQsample() ;
    //  gpio_put(GPIO4, 0);
        }
    }
  }

